﻿Include "casque_data.geo";

Mesh.Algorithm = 1 ;
Geometry.OldNewReg = 0;
Geometry.AutoCoherence = 0;

Include "Lib_DefGeoShapes.geo";

// initialisation

Liste_surface_tete_int[] = {};

// Définition de la tete

x0[] = {0,0,0};
radius = rayon_tete_ext ;
lc = lc_tete;


flag_DefSurface = Flag_tete_ext ;
flag_loopHoles 	= Flag_loopholes_tete;
loopHoles[]	= Liste_surface_tete_int[] ;
flagTransfinite = Flag_transfinite_tete_ext;
flagRecombine 	= Flag_Recombine_tete_ext ;

Call DefPath_GeoCircle ;


Liste_surface[]  =current_numSurface ;
Peau_tete[]	 =current_loop[] ;

// définition du casque

// interieur
xO[] = {0,0,0};
dx[] = {cote_casque, cote_casque};
lc = lc_casque ;

flag_DefSurface = Flag_casque_ext ;
flag_loopHoles 	= Flag_loopholes_casque;
loopHoles[]	= Liste_surface[] ;
flagTransfinite = Flag_transfinite_casque_ext;
flagRecombine 	= Flag_Recombine_casque_ext ;
valBumpX = valBumpX_casque ;
valBumpY = valBumpY_casque ;
	

Call DefPath_GeoRectangle ;

Surface_casque          =  current_numSurface ;
Liste_surface [1] 	=  current_numSurface ;

Peau_casque_int[]	=  current_loop[] ;

// exterieur

xO[] = {0,0,0};
dx[] = {(cote_casque+(bord_casque)), (cote_casque+(bord_casque))};
lc = lc_casque ;

flag_DefSurface = Flag_casque_ext ;
flag_loopHoles 	= Flag_loopholes_casque;
loopHoles[]	= Liste_surface[1] ;
flagTransfinite = Flag_transfinite_casque_ext;
flagRecombine 	= Flag_Recombine_casque_ext ;
valBumpX = valBumpX_casque ;
valBumpY = valBumpY_casque ;
	

Call DefPath_GeoRectangle ;

Surface_casque          =  current_numSurface ;
Liste_surface [2] 	=  current_numSurface ;

Peau_casque_ext[]	=  current_loop[] ;



// Définition des inducteurs 

For i In {0:7}

	If (i == 0)

		x0[] = {((diam_spire/2)+(Hauteur_ind/2)),(bord_casque + (cote_casque/2) + (Largeur_ind/2)),0} ;
		dx[] = {Hauteur_ind, Largeur_ind} ;
		lc = lc_ind12 ;
	EndIf	

	If (i == 1)

		x0[] = {(bord_casque + (cote_casque/2) + (Largeur_ind/2)),((diam_spire/2)+(Hauteur_ind/2)),0} ;
		dx[] = {Largeur_ind, Hauteur_ind} ;
		lc = lc_ind12 ;
	EndIf

	If (i == 2)

	        x0[] =  {(bord_casque + (cote_casque/2) + (Largeur_ind/2)),-1*((diam_spire/2)+(Hauteur_ind/2)),0} ;
		dx[] = {Largeur_ind, Hauteur_ind} ;
		lc = lc_ind12 ;
	EndIf

	If (i == 3)

		x0[] =  {((diam_spire/2)+(Hauteur_ind/2)),-1*(bord_casque + (cote_casque/2) + (Largeur_ind/2)),0} ;
		dx[] = {Hauteur_ind, Largeur_ind} ;
		lc = lc_ind12 ;
        EndIf

	If (i == 7)

		x0[] = {-1*((diam_spire/2)+(Hauteur_ind/2)),(bord_casque + (cote_casque/2) + (Largeur_ind/2)),0} ;
		dx[] = {Hauteur_ind, Largeur_ind} ;
		lc = lc_ind12 ;
	EndIf	

	If (i == 6)

		x0[] = {-1*(bord_casque + (cote_casque/2) + (Largeur_ind/2)),((diam_spire/2)+(Hauteur_ind/2)),0} ;
		dx[] = {Largeur_ind, Hauteur_ind} ;
		lc = lc_ind12 ;
	EndIf

	If (i == 5)

	        x0[] =  {-1*(bord_casque + (cote_casque/2) + (Largeur_ind/2)),-1*((diam_spire/2)+(Hauteur_ind/2)),0} ;
		dx[] = {Largeur_ind, Hauteur_ind} ;
		lc = lc_ind12 ;
	EndIf

	If (i == 4)

		x0[] =  {-1*((diam_spire/2)+(Hauteur_ind/2)),-1*(bord_casque + (cote_casque/2) + (Largeur_ind/2)),0} ;
		dx[] = {Hauteur_ind, Largeur_ind} ;
		lc = lc_ind12 ;
	EndIf
	


	flag_DefSurface = Flag_DefSurface_ind ;
	flag_loopHoles  = Flag_loopHoles_ind ;
	loopHoles[]	= {} ;
	flagTransfinite	= Flag_transfinite_ind ;
	valBumpX = valBumpX_ind ;
	valBumpY = valBumpY_ind ;
	flagRecombine	= Flag_recombine_ind ;

	Call DefPath_GeoRectangle ;

	Liste_surface_ind[i] 	= current_numSurface ;
        Liste_surface[i+3] 	= current_numSurface ; // attention +3 si surface casque pris en compte
	Peau_ind[]		+= current_loop[] ;
EndFor	



// Définition de l'air

x0[] = {0,0,0};
radius = rayon_air ;
lc= lc_air ;

flag_DefSurface = Flag_Defsurface_air ;
flag_loopHoles 	= Flag_loopholes_air;
loopHoles[]	= Liste_surface[{2:10}] ;  // doit rajouter les surfaces en contact uniquement... 
flagTransfinite = Flag_transfinite_air;
flagRecombine 	= Flag_Recombine_air ;

Call DefPath_GeoCircle ;

Surface_air	= current_numSurface ;
Peau_air[]	= current_loop[] ;


// Définition de l'air infini

x0[] = {0,0,0};
radius = rayon_air_inf; 
lc= lc_air_inf ;

flag_DefSurface = Flag_Defsurface_air_inf ;
flag_loopHoles 	= Flag_loopholes_air_inf;
loopHoles[]	= Surface_air ;
flagTransfinite = Flag_transfinite_air_inf;
flagRecombine 	= Flag_Recombine_air_inf ;

Call DefPath_GeoCircle ;

Surface_air_inf = current_numSurface ;
Peau_air_inf[]	= current_loop[] ;

// Regions physiques

Physical Line(PEAU_CASQUE_INT)	= Peau_casque_int[] ;
Physical Line(PEAU_CASQUE_EXT)	= Peau_casque_ext[] ;
Physical Line(PEAU_TETE)	= Peau_tete[] ;
Physical Line(PEAU_IND)		= Peau_ind[] ;
Physical Line(PEAU_AIR)		= Peau_air[] ;
Physical Line(PEAU_AIR_INF)	= Peau_air_inf[] ;


//Physical Line(PEAU_IND+1)      = {9:12,21:28,37:40} ;
//Physical Line(PEAU_IND+2)      = {13:20,29:36} ;



// Surfaces physiques


Physical Surface (TETE)	        = Liste_surface[0];
Physical Surface (CASQUE_INT)   = Liste_surface[1];
Physical Surface (CASQUE)	= Liste_surface[2];
Physical Surface (IND_H) 	= {Liste_surface_ind[0],Liste_surface_ind[7]};
Physical Surface (IND_D)	= {Liste_surface_ind[1],Liste_surface_ind[2]};
Physical Surface (IND_B)	= {Liste_surface_ind[3],Liste_surface_ind[4]}; 
Physical Surface (IND_G)	= {Liste_surface_ind[5],Liste_surface_ind[6]};
Physical Surface (AIR)		= Surface_air;
Physical Surface (AIR_INF)	= Surface_air_inf;

// couleur des surfaces (parce que je trouve aussi que c'est beau)

Color Red{Surface{Liste_surface[0]};}
Color Grey20{Surface{Liste_surface[1]};}
Color Blue{Surface{Liste_surface[2]};}
Color Yellow{Surface{Liste_surface_ind[0],Liste_surface_ind[3],Liste_surface_ind[4],Liste_surface_ind[7]};}
Color Green{Surface{Liste_surface_ind[1],Liste_surface_ind[2],Liste_surface_ind[5],Liste_surface_ind[6]};}
Color Grey20{Surface{Surface_air,Surface_air_inf};}

Coherence ;
